diff -Naur --no-dereference a/ti_config_fragments/dra7_only.cfg b/ti_config_fragments/dra7_only.cfg
--- a/ti_config_fragments/dra7_only.cfg	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/dra7_only.cfg	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,25 @@
+##################################################
+# TI DRA7 specific config options
+##################################################
+
+# Supported ARM CPUs
+CONFIG_ARCH_MULTI_V6=n
+CONFIG_ARCH_MULTI_V7=y
+CONFIG_ARCH_MULTI_V6_V7=n
+CONFIG_CPU_V6=n
+
+# Enable CONFIG_SMP
+CONFIG_SMP=y
+
+# Disable Socs other than DRA7
+CONFIG_ARCH_OMAP2=n
+CONFIG_ARCH_OMAP3=n
+CONFIG_ARCH_OMAP4=n
+CONFIG_SOC_OMAP5=n
+CONFIG_SOC_AM33XX=n
+CONFIG_SOC_AM43XX=n
+CONFIG_SOC_DRA7XX=y
+
+CONFIG_ARCH_KEYSTONE=n
+
+CONFIG_ARM_LPAE=y
diff -Naur --no-dereference a/ti_config_fragments/ipc.cfg b/ti_config_fragments/ipc.cfg
--- a/ti_config_fragments/ipc.cfg	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/ipc.cfg	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,29 @@
+##################################################
+# TI RPMsg/IPC Config Options
+##################################################
+# HwSpinLock
+CONFIG_HWSPINLOCK_OMAP=y
+
+# Mailbox
+CONFIG_OMAP2PLUS_MBOX=y
+
+# IOMMU
+CONFIG_IOMMU_SUPPORT=y
+CONFIG_OMAP_IOMMU=y
+CONFIG_OMAP_IOMMU_DEBUG=y
+
+# Remoteproc
+CONFIG_OMAP_REMOTEPROC=m
+CONFIG_OMAP_REMOTEPROC_WATCHDOG=y
+CONFIG_KEYSTONE_REMOTEPROC=m
+CONFIG_PRUSS_REMOTEPROC=m
+
+# DSP Memory Mapper for MPM
+CONFIG_KEYSTONE_DSP_MEM=m
+
+# RPMsg
+CONFIG_RPMSG_RPC=m
+CONFIG_RPMSG_PRU=m
+
+# UIO Module
+CONFIG_UIO=m
diff -Naur --no-dereference a/ti_config_fragments/k2g_only.cfg b/ti_config_fragments/k2g_only.cfg
--- a/ti_config_fragments/k2g_only.cfg	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/k2g_only.cfg	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,7 @@
+##################################################
+# TI K2G (UP) specific config options
+##################################################
+
+# Disable SMP related options
+CONFIG_SMP=n
+CONFIG_CPUSETS=n
diff -Naur --no-dereference a/ti_config_fragments/lpae.cfg b/ti_config_fragments/lpae.cfg
--- a/ti_config_fragments/lpae.cfg	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/lpae.cfg	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1 @@
+CONFIG_ARM_LPAE=y
diff -Naur --no-dereference a/ti_config_fragments/multi_core_defconfig_fragment b/ti_config_fragments/multi_core_defconfig_fragment
--- a/ti_config_fragments/multi_core_defconfig_fragment	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/multi_core_defconfig_fragment	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,7 @@
+use-kernel-config=multi_v7_defconfig
+config-fragment=ti_config_fragments/multi_v7_prune.cfg
+config-fragment=ti_config_fragments/lpae.cfg
+config-fragment=ti_config_fragments/baseport.cfg
+config-fragment=ti_config_fragments/audio_display.cfg
+config-fragment=ti_config_fragments/connectivity.cfg
+config-fragment=ti_config_fragments/ipc.cfg
diff -Naur --no-dereference a/ti_config_fragments/multi_core_system_test_defconfig_fragment b/ti_config_fragments/multi_core_system_test_defconfig_fragment
--- a/ti_config_fragments/multi_core_system_test_defconfig_fragment	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/multi_core_system_test_defconfig_fragment	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,9 @@
+use-kernel-config=multi_v7_defconfig
+config-fragment=ti_config_fragments/multi_v7_prune.cfg
+config-fragment=ti_config_fragments/lpae.cfg
+config-fragment=ti_config_fragments/baseport.cfg
+config-fragment=ti_config_fragments/audio_display.cfg
+config-fragment=ti_config_fragments/connectivity.cfg
+config-fragment=ti_config_fragments/ipc.cfg
+config-fragment=ti_config_fragments/debug_options.cfg
+config-fragment=ti_config_fragments/system_test.cfg
diff -Naur --no-dereference a/ti_config_fragments/multi_v7_prune.cfg b/ti_config_fragments/multi_v7_prune.cfg
--- a/ti_config_fragments/multi_v7_prune.cfg	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/multi_v7_prune.cfg	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,57 @@
+# Add config flags here that only appear in the multi_v7_defconfig
+CONFIG_ARCH_ALPINE=n
+CONFIG_ARCH_AT91=n
+CONFIG_ARCH_BCM=n
+CONFIG_ARCH_BCM_CYGNUS=n
+CONFIG_ARCH_BCM_NSP=n
+CONFIG_ARCH_BCM_5301X=n
+CONFIG_ARCH_BCM_281XX=n
+CONFIG_ARCH_BCM_21664=n
+CONFIG_ARCH_BRCMSTB=n
+CONFIG_ARCH_BERLIN=n
+CONFIG_ARCH_DIGICOLOR=n
+CONFIG_ARCH_HIGHBANK=n
+CONFIG_ARCH_HISI=n
+CONFIG_ARCH_HI3xxx=n
+CONFIG_ARCH_HIP01=n
+CONFIG_ARCH_HIP04=n
+CONFIG_ARCH_HIX5HD2=n
+CONFIG_ARCH_MESON=n
+CONFIG_ARCH_MXC=n
+CONFIG_ARCH_MEDIATEK=n
+CONFIG_ARCH_QCOM=n
+CONFIG_ARCH_MSM8X60=n
+CONFIG_ARCH_MSM8960=n
+CONFIG_ARCH_MSM8974=n
+CONFIG_ARCH_ROCKCHIP=n
+CONFIG_ARCH_SOCFPGA=n
+CONFIG_ARCH_SPEAR13XX=n
+CONFIG_ARCH_STI=n
+CONFIG_ARCH_EXYNOS=n
+CONFIG_ARCH_SHMOBILE_MULTI=n
+CONFIG_ARCH_EMEV2=n
+CONFIG_ARCH_R7S72100=n
+CONFIG_ARCH_R8A73A4=n
+CONFIG_ARCH_R8A7740=n
+CONFIG_ARCH_R8A7778=n
+CONFIG_ARCH_R8A7779=n
+CONFIG_ARCH_R8A7790=n
+CONFIG_ARCH_R8A7791=n
+CONFIG_ARCH_R8A7793=n
+CONFIG_ARCH_R8A7794=n
+CONFIG_ARCH_SH73A0=n
+CONFIG_ARCH_SUNXI=n
+CONFIG_ARCH_SIRF=n
+CONFIG_ARCH_TEGRA=n
+CONFIG_ARCH_TEGRA_2x_SOC=n
+CONFIG_ARCH_TEGRA_3x_SOC=n
+CONFIG_ARCH_TEGRA_114_SOC=n
+CONFIG_ARCH_TEGRA_124_SOC=n
+CONFIG_ARCH_UNIPHIER=n
+CONFIG_ARCH_U8500=n
+CONFIG_ARCH_VEXPRESS=n
+CONFIG_ARCH_VEXPRESS_TC2_PM=n
+CONFIG_ARCH_WM8850=n
+CONFIG_ARCH_ZYNQ=n
+CONFIG_ARCH_VIRT=n
+CONFIG_ARCH_MVEBU=n
diff -Naur --no-dereference a/ti_config_fragments/omap5_soc.cfg b/ti_config_fragments/omap5_soc.cfg
--- a/ti_config_fragments/omap5_soc.cfg	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/omap5_soc.cfg	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,14 @@
+##################################################
+# TI OMAP5 EVM specific config options
+##################################################
+
+#ETHERNET
+CONFIG_USB_USBNET=y
+CONFIG_USB_NET_DRIVERS=y
+CONFIG_USB_NET_SMSC95XX=y
+
+#USB HOST
+CONFIG_USB=y
+CONFIG_USB_EHCI_HCD=y
+CONFIG_USB_EHCI_PCI=y
+CONFIG_USB_EHCI_HCD_OMAP=y
diff -Naur --no-dereference a/ti_config_fragments/README b/ti_config_fragments/README
--- a/ti_config_fragments/README	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/README	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,143 @@
+
+			     TI defconfig Fragments
+
+Description
+===========
+
+The Linux kernel contains a script that takes a base defconfig and merges
+defconfig fragment files into a final buildable configuration for your target.
+
+TI Defconfig Merge Script Usage
+===============================
+
+1.0 Script contents
+-------------------
+
+This script will either take in a single defconfig fragment file or a file with
+multiple fragments defined.  With either file the base defconfig will initially
+be built, copied to a working directory, and the kernels merge_config script
+will be called for each config file fragment.  Each config file fragment will
+be appended to the base config and then the final output will be copied back to
+the kernels working directory.
+
+A copy of both the base config and the final config is stored in the scripts
+logging directory.
+
+Single fragment command line example:
+-------------------------------------
+
+	$ defconfig_merge.sh -c <path to the compiler>	\
+		-o <output directory and file name>	\
+		-e <path to single fragment file>	\
+		-w <path to kernel's working directory>
+
+"use-kernel-config=" - Is required to be defined.  This is the base defconfig
+that the config fragments will be appended to.  This defconfig should be in the
+Linux kernel path in arch/arm/configs.
+
+	use-kernel-config= < defconfig base to start appending fragments >
+
+"config-fragment=" - Is required to be defined.  There should be at least one
+entry per config fragment.
+
+	config-fragment= < path to the defconfig fragment file 1>
+
+Multiple fragment command line example:
+---------------------------------------
+
+	export CROSS_COMPILE=~/linux_kernel/docs/toolchain/linaro-4.7/bin/arm-linux-gnueabihf-
+
+	./ti_config_fragments/defconfig_merge.sh -o ~/Desktop/kernel/notes/kernel.txt
+	-f ~/linux_kernel/lcpd_kernel/ti_config_fragments/defconfig_fragment -m
+	-w ~/linux_kernel/lcpd_kernel/ -c $CROSS_COMPILE
+
+
+Example:
+use-kernel-config=omap2plus_defconfig
+config-fragment=baseport.cfg
+config-fragment=power.cfg
+config-fragment=connectivity.cfg
+config-fragment=ipc.cfg
+config-fragment=audio_display.cfg
+config-fragment=system_test.cfg
+
+
+OPTIONS:
+	Setup Options:
+	-c  The path to the desired compiler
+	-d  The defconfig to use as a base
+	-e  Single defconfig fragment to append
+	-j  How many build threads to use
+	-o  Output log
+	-l  uImage load address if different from 0x80008000 for no load address use ""
+
+	Build Options:
+	-n  Do not pre-build the defconfig just use the existing .config
+	-m  MAKE the kernel, modules and dtb files based on the new config
+	-w  Linux kernel path directory
+
+	-f  Path to file with multiple defconfig options
+
+2.0 Config Fragment File
+------------------------
+
+The config fragment file contains the CONFIG options that will need to be
+turned on or off based on a base defconfig.
+
+To turn on a config flag you merely create a file of any name and populate it
+with CONFIG_BAR=y
+
+Of course if CONFIG_BAR has a parent dependency, say CONFIG_FOO you will need
+to turn that CONFIG option on as well so your file will need to look like this
+
+CONFIG_FOO=y
+CONFIG_BAR=y
+
+You may want to disable a certain config option.  Normally in the config file
+it is custumary to have an entry like this
+
+# CONFIG_FOO is not set
+
+Well the merge_config.sh within the kernel strips out all comments from the
+passed in Config fragment file.  So in order to turn off a config option you
+will need to explicitly state
+
+CONFIG_FOO=n
+
+Linux Kernel Script Location:
+=============================
+
+scripts/Kconfig/merge_config.sh
+
+Linux Kernel Script Usage
+=========================
+
+To have the latest script usage information displayed please use the
+command below in any linux kernel.
+
+./scripts/Kconfig/merge_config.sh -h
+
+Example:
+
+./scripts/kconfig/merge_config.sh -m -r -O <LOGGING_DIRECTORY> <APPENDED_CONFIGs>
+
+In this example:
+-m  =  only merge the fragments, do not execute the make command
+-n  =  use allnoconfig instead of alldefconfig
+-r  =  list redundant entries when merging fragments
+-O  =  dir to put generated output files
+
+TI Configuration files
+======================
+
+Below is a list of configuration files for each domain within TI.
+
+These files contain configuration flags that are not currently set in the
+omap2plus_defconfig but these features are available within the TI integration
+kernel.
+
+TI Baseport - baseport.cfg
+TI Connectivity - connectivity.cfg
+TI Audio and Display - audio_display.cfg
+TI Power - power.cfg
+TI System Test add-ons - system_test.cfg
diff -Naur --no-dereference a/ti_config_fragments/real_time.cfg b/ti_config_fragments/real_time.cfg
--- a/ti_config_fragments/real_time.cfg	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/real_time.cfg	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,37 @@
+##################################################
+# Real Time Linux Configs
+##################################################
+
+CONFIG_PREEMPT=y
+CONFIG_PREEMPT_RT_BASE=y
+CONFIG_PREEMPT_RT_FULL=y 
+
+#Disable PM features
+CONFIG_CPU_IDLE=n
+CONFIG_CPU_FREQ=n
+CONFIG_SUSPEND=n
+CONFIG_HOTPLUG_CPU=n
+
+# SCHED_DEBUG provides a lot of additional options for scheduler
+# tuning in /proc/sys/kernel/ and allows to see scheduler statistic in
+# /proc/sched_debug
+# CONFIG_SCHED_DEBUG
+
+# --- RCU optimization options to reduce OS jitter
+# RCU_BOOST : This option boosts the priority of preempted RCU readers that
+# block the current preemptible RCU grace period for too long.
+# This option also prevents heavy loads from blocking RCU
+# callback invocation for all flavors of RCU
+# CONFIG_RCU_BOOST=n
+
+# RCU_NOCB_CPU : Use this option to reduce OS jitter for aggressive HPC or
+# real-time workloads.	It can also be used to offload RCU
+# callback invocation to energy-efficient CPUs in battery-powered
+# asymmetric multiprocessors.
+# CONFIG_RCU_NOCB_CPU=y
+
+# RCU_NOCB_CPU_ALL: his option forces all CPUs to be no-CBs CPUs.
+# The rcu_nocbs= boot parameter will be ignored.  All CPUs' RCU callbacks will
+# be executed in the context of per-CPU rcuo kthreads created for
+# this purpose.
+# CONFIG_RCU_NOCB_CPU_ALL=y
diff -Naur --no-dereference a/ti_config_fragments/rt_defconfig_fragment b/ti_config_fragments/rt_defconfig_fragment
--- a/ti_config_fragments/rt_defconfig_fragment	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/rt_defconfig_fragment	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,7 @@
+use-kernel-config=multi_v7_defconfig
+config-fragment=ti_config_fragments/multi_v7_prune.cfg
+config-fragment=ti_config_fragments/real_time.cfg
+config-fragment=ti_config_fragments/baseport.cfg
+config-fragment=ti_config_fragments/audio_display.cfg
+config-fragment=ti_config_fragments/ipc.cfg
+config-fragment=ti_config_fragments/connectivity.cfg
diff -Naur --no-dereference a/ti_config_fragments/rt_multi_core_defconfig_fragment b/ti_config_fragments/rt_multi_core_defconfig_fragment
--- a/ti_config_fragments/rt_multi_core_defconfig_fragment	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/rt_multi_core_defconfig_fragment	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,8 @@
+use-kernel-config=multi_v7_defconfig
+config-fragment=ti_config_fragments/multi_v7_prune.cfg
+config-fragment=ti_config_fragments/lpae.cfg
+config-fragment=ti_config_fragments/real_time.cfg
+config-fragment=ti_config_fragments/baseport.cfg
+config-fragment=ti_config_fragments/audio_display.cfg
+config-fragment=ti_config_fragments/connectivity.cfg
+config-fragment=ti_config_fragments/ipc.cfg
diff -Naur --no-dereference a/ti_config_fragments/rt_multi_core_system_test_defconfig_fragment b/ti_config_fragments/rt_multi_core_system_test_defconfig_fragment
--- a/ti_config_fragments/rt_multi_core_system_test_defconfig_fragment	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/rt_multi_core_system_test_defconfig_fragment	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,10 @@
+use-kernel-config=multi_v7_defconfig
+config-fragment=ti_config_fragments/multi_v7_prune.cfg
+config-fragment=ti_config_fragments/lpae.cfg
+config-fragment=ti_config_fragments/real_time.cfg
+config-fragment=ti_config_fragments/baseport.cfg
+config-fragment=ti_config_fragments/audio_display.cfg
+config-fragment=ti_config_fragments/connectivity.cfg
+config-fragment=ti_config_fragments/ipc.cfg
+config-fragment=ti_config_fragments/debug_options.cfg
+config-fragment=ti_config_fragments/system_test.cfg
diff -Naur --no-dereference a/ti_config_fragments/rt_system_test_defconfig_fragment b/ti_config_fragments/rt_system_test_defconfig_fragment
--- a/ti_config_fragments/rt_system_test_defconfig_fragment	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/rt_system_test_defconfig_fragment	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,9 @@
+use-kernel-config=multi_v7_defconfig
+config-fragment=ti_config_fragments/multi_v7_prune.cfg
+config-fragment=ti_config_fragments/real_time.cfg
+config-fragment=ti_config_fragments/baseport.cfg
+config-fragment=ti_config_fragments/audio_display.cfg
+config-fragment=ti_config_fragments/ipc.cfg
+config-fragment=ti_config_fragments/connectivity.cfg
+config-fragment=ti_config_fragments/debug_options.cfg
+config-fragment=ti_config_fragments/system_test.cfg
diff -Naur --no-dereference a/ti_config_fragments/system_test.cfg b/ti_config_fragments/system_test.cfg
--- a/ti_config_fragments/system_test.cfg	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/system_test.cfg	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,24 @@
+##################################################
+# TI System Test config options
+##################################################
+CONFIG_CRYPTO_MANAGER_DISABLE_TESTS=n
+CONFIG_CRYPTO_TEST=m
+CONFIG_RTC_DEBUG=y
+CONFIG_THERMAL_EMULATION=y
+# Enable Devfreq for co-processor driver testing
+CONFIG_PM_DEVFREQ=y
+CONFIG_DEVFREQ_GOV_SIMPLE_ONDEMAND=y
+CONFIG_DEVFREQ_GOV_PERFORMANCE=y
+CONFIG_DEVFREQ_GOV_POWERSAVE=y
+CONFIG_DEVFREQ_GOV_USERSPACE=y
+
+# OMAP5 EVM ETHERNET
+CONFIG_USB_USBNET=y
+CONFIG_USB_NET_DRIVERS=y
+CONFIG_USB_NET_SMSC95XX=y
+
+# OMAP5 EVM USB HOST
+CONFIG_USB=y
+CONFIG_USB_EHCI_HCD=y
+CONFIG_USB_EHCI_PCI=y
+CONFIG_USB_EHCI_HCD_OMAP=y
diff -Naur --no-dereference a/ti_config_fragments/system_test_defconfig_fragment b/ti_config_fragments/system_test_defconfig_fragment
--- a/ti_config_fragments/system_test_defconfig_fragment	1969-12-31 19:00:00.000000000 -0500
+++ b/ti_config_fragments/system_test_defconfig_fragment	2016-05-11 13:31:53.221225428 -0400
@@ -0,0 +1,8 @@
+use-kernel-config=multi_v7_defconfig
+config-fragment=ti_config_fragments/multi_v7_prune.cfg
+config-fragment=ti_config_fragments/baseport.cfg
+config-fragment=ti_config_fragments/audio_display.cfg
+config-fragment=ti_config_fragments/connectivity.cfg
+config-fragment=ti_config_fragments/ipc.cfg
+config-fragment=ti_config_fragments/debug_options.cfg
+config-fragment=ti_config_fragments/system_test.cfg
diff -Naur --no-dereference a/virt/kvm/async_pf.c b/virt/kvm/async_pf.c
--- a/virt/kvm/async_pf.c	2016-05-04 17:50:15.000000000 -0400
+++ b/virt/kvm/async_pf.c	2016-05-11 13:31:53.221225428 -0400
@@ -98,8 +98,8 @@
 	 * This memory barrier pairs with prepare_to_wait's set_current_state()
 	 */
 	smp_mb();
-	if (waitqueue_active(&vcpu->wq))
-		wake_up_interruptible(&vcpu->wq);
+	if (swait_active(&vcpu->wq))
+		swake_up(&vcpu->wq);
 
 	mmput(mm);
 	kvm_put_kvm(vcpu->kvm);
diff -Naur --no-dereference a/virt/kvm/kvm_main.c b/virt/kvm/kvm_main.c
--- a/virt/kvm/kvm_main.c	2016-05-04 17:50:15.000000000 -0400
+++ b/virt/kvm/kvm_main.c	2016-05-11 13:31:53.221225428 -0400
@@ -226,8 +226,7 @@
 	vcpu->kvm = kvm;
 	vcpu->vcpu_id = id;
 	vcpu->pid = NULL;
-	vcpu->halt_poll_ns = 0;
-	init_waitqueue_head(&vcpu->wq);
+	init_swait_queue_head(&vcpu->wq);
 	kvm_async_pf_vcpu_init(vcpu);
 
 	vcpu->pre_pcpu = -1;
@@ -2003,7 +2002,7 @@
 void kvm_vcpu_block(struct kvm_vcpu *vcpu)
 {
 	ktime_t start, cur;
-	DEFINE_WAIT(wait);
+	DECLARE_SWAITQUEUE(wait);
 	bool waited = false;
 	u64 block_ns;
 
@@ -2028,7 +2027,7 @@
 	kvm_arch_vcpu_blocking(vcpu);
 
 	for (;;) {
-		prepare_to_wait(&vcpu->wq, &wait, TASK_INTERRUPTIBLE);
+		prepare_to_swait(&vcpu->wq, &wait, TASK_INTERRUPTIBLE);
 
 		if (kvm_vcpu_check_block(vcpu) < 0)
 			break;
@@ -2037,7 +2036,7 @@
 		schedule();
 	}
 
-	finish_wait(&vcpu->wq, &wait);
+	finish_swait(&vcpu->wq, &wait);
 	cur = ktime_get();
 
 	kvm_arch_vcpu_unblocking(vcpu);
@@ -2069,11 +2068,11 @@
 {
 	int me;
 	int cpu = vcpu->cpu;
-	wait_queue_head_t *wqp;
+	struct swait_queue_head *wqp;
 
 	wqp = kvm_arch_vcpu_wq(vcpu);
-	if (waitqueue_active(wqp)) {
-		wake_up_interruptible(wqp);
+	if (swait_active(wqp)) {
+		swake_up(wqp);
 		++vcpu->stat.halt_wakeup;
 	}
 
@@ -2174,7 +2173,7 @@
 				continue;
 			if (vcpu == me)
 				continue;
-			if (waitqueue_active(&vcpu->wq) && !kvm_arch_vcpu_runnable(vcpu))
+			if (swait_active(&vcpu->wq) && !kvm_arch_vcpu_runnable(vcpu))
 				continue;
 			if (!kvm_vcpu_eligible_for_directed_yield(vcpu))
 				continue;
